=== build/pkgs/ore_algebra/requirements.txt ===
git+https://github.com/mkauers/ore_algebra@6826ac49b4cdf66a563449aced21a2fd1fd085c9#egg=ore_algebra
